import { createRoute, OpenAPIHono, z } from "@hono/zod-openapi";
import { responses } from "../../../globalUtils/routeDefs/responses.js";
import { tryCatch } from "../../../globalUtils/tryCatch.js";
import { apiHit } from "../../../globalUtils/apiHits.js";
import { getDeliveryByDateRangeAndAv } from "../controller/getDeliveryByDateRangeAndAv.js";

const app = new OpenAPIHono({ strict: false });
const Body = z.object({
    includeRunnningNumbers: z.string().openapi({ example: "x" }),
});
app.openapi(
    createRoute({
        tags: ["dataMart"],
        summary: "Returns deliverys by daterange.",
        method: "get",
        path: "/deliverybydaterangeandav",
        request: {
            body: {
                content: {
                    "application/json": { schema: Body },
                },
            },
        },
        responses: responses(),
    }),
    async (c) => {
        const q: any = c.req.queries();

        // make sure we have a vaid user being accessed thats really logged in
        apiHit(c, { endpoint: "/deliverybydaterangeandav" });
        const { data, error } = await tryCatch(
            getDeliveryByDateRangeAndAv(
                q["avs"] ? q["avs"][0] : null,
                q["startDate"] ? q["startDate"][0] : null,
                q["endDate"] ? q["endDate"][0] : null
            )
        );

        if (error) {
            console.log(error);
            return c.json(
                {
                    success: false,
                    message: "There was an error getting the deliveries.",
                    data: error,
                },
                400
            );
        }

        return c.json({
            success: data.success,
            message: data.message,
            data: data.data,
        });
    }
);
export default app;
